#!/usr/bin/env python3
# @generated AUTOGENERATED file. Do not Change!

from dataclasses import dataclass, field as _field
from ..schema_config.json_scalar import custom_scalars
from gql_client.runtime.variables import encode_variables
from gql import gql, Client
from gql.transport.exceptions import TransportQueryError
from functools import partial
from numbers import Number
from typing import Any, AsyncGenerator, Dict, List, Generator, Optional
from time import perf_counter
from dataclasses_json import DataClassJsonMixin, config


# fmt: off
QUERY: List[str] = ["""
query textToSpeech($text: String!) {
  callTextToSpeech(text: $text) {
    audio: audioB64
  }
}

"""
]


class textToSpeech:
    @dataclass(frozen=True)
    class textToSpeechData(DataClassJsonMixin):
        @dataclass(frozen=True)
        class TTSResult(DataClassJsonMixin):
            audio: Optional[str]

        callTextToSpeech: Optional[TTSResult]

    # fmt: off
    @classmethod
    def execute(cls, client: Client, text: str) -> Optional[textToSpeechData.TTSResult]:
        variables: Dict[str, Any] = {"text": text}
        new_variables = encode_variables(variables, custom_scalars)
        response_text = client.execute(
            gql("".join(set(QUERY))), variable_values=new_variables
        )
        res = cls.textToSpeechData.from_dict(response_text)
        return res.callTextToSpeech

    # fmt: off
    @classmethod
    async def execute_async(cls, client: Client, text: str) -> Optional[textToSpeechData.TTSResult]:
        variables: Dict[str, Any] = {"text": text}
        new_variables = encode_variables(variables, custom_scalars)
        response_text = await client.execute_async(
            gql("".join(set(QUERY))), variable_values=new_variables
        )
        res = cls.textToSpeechData.from_dict(response_text)
        return res.callTextToSpeech
